import click
from app.api import api
from app.scheduler import scheduler
from app.host import host
from app.image import image
from app.file import file_scan
from app.cli import cli

@click.group()
def entry_point():
    pass


entry_point.add_command(api)
entry_point.add_command(scheduler)
entry_point.add_command(host)
entry_point.add_command(image)
entry_point.add_command(file_scan)
entry_point.add_command(cli)


if __name__ == "__main__":
    entry_point()
